/**
 * arrays.hpp
 *
 * Author: Damian Eads
 * Date:   March 29, 2008
 *
 * Chestnut Scientific Library
 * Copyright (C) 2008, Damian Eads. All Rights Reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

class ContiguousStride {
  
};

template class < DT >
class DiscontiguousStride {

  virtual Matrix<DT, DiscontiguousStride<DT> > getIndex(int i) {

  }

};

template <typename DT, typename Stride< DT > = Contiguous< DT >>
class Matrix {

private:
  size_t nd;
  size_t *shape;
  size_t *strides;
}
